#[doc = "Register `CFG10` reader"]
pub struct R(crate::R<CFG10_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CFG10_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CFG10_SPEC>> for R {
    fn from(reader: crate::R<CFG10_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CFG10` writer"]
pub struct W(crate::W<CFG10_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CFG10_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CFG10_SPEC>> for W {
    fn from(writer: crate::W<CFG10_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CMASK0` reader - Datapath Compare 0 Mask. The mask value in this register is applied to the output of the Accumulator 0 before it is used for comparison in Compare block 0. The CMASK0_EN bit (CFG12) must be set for the mask to be operational."]
pub struct CMASK0_R(crate::FieldReader<u8, u8>);
impl CMASK0_R {
    pub(crate) fn new(bits: u8) -> Self {
        CMASK0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for CMASK0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CMASK0` writer - Datapath Compare 0 Mask. The mask value in this register is applied to the output of the Accumulator 0 before it is used for comparison in Compare block 0. The CMASK0_EN bit (CFG12) must be set for the mask to be operational."]
pub struct CMASK0_W<'a> {
    w: &'a mut W,
}
impl<'a> CMASK0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Datapath Compare 0 Mask. The mask value in this register is applied to the output of the Accumulator 0 before it is used for comparison in Compare block 0. The CMASK0_EN bit (CFG12) must be set for the mask to be operational."]
    #[inline(always)]
    pub fn cmask0(&self) -> CMASK0_R {
        CMASK0_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Datapath Compare 0 Mask. The mask value in this register is applied to the output of the Accumulator 0 before it is used for comparison in Compare block 0. The CMASK0_EN bit (CFG12) must be set for the mask to be operational."]
    #[inline(always)]
    pub fn cmask0(&mut self) -> CMASK0_W {
        CMASK0_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Datapath Compare 0 Mask\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cfg10](index.html) module"]
pub struct CFG10_SPEC;
impl crate::RegisterSpec for CFG10_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cfg10::R](R) reader structure"]
impl crate::Readable for CFG10_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cfg10::W](W) writer structure"]
impl crate::Writable for CFG10_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CFG10 to value 0"]
impl crate::Resettable for CFG10_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
